c*       unit 3: data to fit
c*       unit 5: variable parameters 
c*       unit 6: output
c*
       program fitpol
       external fcn
        call mintio(31,33,34) ! read fort.31, write fort.33, save fort.34
c
        call minuit(fcn,0)
c       call minnew
       end
c
       subroutine fcn(nparm,gg,chisqt,coeff,iflag)
       real*8 chisq
       integer*4 nparm,iflag

       real*8 gg(*),coeff(*), chisqt
c
      integer mval,npt
      parameter (mval=100)
      real*8 yp(mval),xp(mval),delta(mval)
      real*8 yp_known(mval)
      real*8 yp_calc(mval)

c
c
      common /data/ yp,xp,delta,yp_known,npt
c
c
       go to (10,20,30,40,50) iflag
C
C  10=READ IN DATA; (CALL FCN 1 IS DONE AUTOMATICALLY BY MINNEW
C  20=FCN CALCULATES GRADIENT (A GRADIENT COMMAND IN THE
C     MINNEW COMMAND FILE SETS IFLAG=2) THIS IS NOT AN OPTION
C     FOR THIS PROGRAM
C  30=PRINT OUTPUT AFTER MINIMIZATION IS COMPLETE (FCN WITH
C     IFLAG=3 IS AUTOMATICALLY CALLED IF AN END, EXIT, OR
C     RETURN END IS ENCOUNTERED IN THE MINNEW COMMAND FILE
C     WITHOUT A CALL FCN 3 BEING EXECUTED
C  40=THE COMMAND MINIMIZE SETS IFLAG=4 AND SIMPLEX AND MIGRAD
C     ARE USED IN THE MINIMIZATION
C  50=RESERVED (IFLAG=5)
c
c       read in data
10     continue
       call get_data
c       do i=1,npt
c          write(20,*) yp(i),xp(i),delta(i),yp_known(i)
c       enddo
       go to 40
c
 20    return
c
30     goto 50
c
40    continue
c
c
      chisq = 0
      do i=1,npt
         yp_calc(i) = coeff(1) + coeff(2)*yp(i) + coeff(3)*xp(i)
         chisq = chisq
     >     + (yp_calc(i)-yp_known(i))*(yp_calc(i)-yp_known(i))
      enddo
      chisqt = chisq
       return
c
50     continue
      chisq = 0
      do i=1,npt
         yp_calc(i) = coeff(1) + coeff(2)*yp(i) + coeff(3)*xp(i)
         chisq = chisq
     >     + (yp_calc(i)-yp_known(i))*(yp_calc(i)-yp_known(i))
      enddo
      chisqt = chisq
       do i=1,npt
          write(23,*) yp(i),xp(i),delta(i),yp_known(i),yp_calc(i)
       enddo
        return
       end
c
      subroutine get_data
c
      integer mval,npt
      parameter (mval=100)
      real*8 yp(mval),xp(mval),delta(mval)
      real*8 yp_known(mval)

c
c
      common /data/ yp,xp,delta,yp_known,npt
c
c
c
      open(1,file='simple_fit.dat',status='old')
      npt=0
      do i=1,mval
         read(1,*,err=888,end=888) yp(i),xp(i),delta(i),yp_known(i)
         npt = npt + 1
         enddo
c
 888     return
         end
c
